<?php

function brifa_portfolio_page( $options ) {
    $page_id = 0;
    if ( isset( $_REQUEST['post'] ) || isset( $_REQUEST['post_ID'] ) ) {
        $page_id = empty( $_REQUEST['post_ID'] ) ? $_REQUEST['post'] : $_REQUEST['post_ID'];
    }

    $current_page_template = get_post_meta( $page_id, '_wp_page_template', true );
    if ( ! in_array( $current_page_template, array( 'page-templates/portfolio.php' ) ) ) {
        return $options;
    }

    $options[] = array(
        'id'        => 'brifa-section-gallery',
        'title'     => __( 'Gallery Settings', 'brifa' ),
        'post_type' => 'page',
        'context'   => 'normal',
        'priority'  => 'default',
        'sections'  => array(
            array(
                'name'   => 'brifa-gallery-section-one',
                'icon'   => 'fa fa-image',
                'fields' => array(
                    array(
                        'id'              => 'portfolio',
                        'type'            => 'group',
                        'title'           => __( 'Portfolio', 'brifa' ),
                        'button_title'    => __( 'New Image', 'brifa' ),
                        'accordion_title' => __( 'Add New Image', 'brifa' ),
                        'fields'          => array(
                            array(
                                'id'    => 'title',
                                'title' => __( 'Title', 'brifa' ),
                                'type'  => 'text',
                            ),
                            array(
                                'id'    => 'image',
                                'title' => __( 'Image', 'brifa' ),
                                'type'  => 'image',
                            ),
                            array(
                                'id'    => 'categories',
                                'title' => __( 'Categories', 'brifa' ),
                                'type'  => 'text',
                            ),
                            array(
                                'id'    => 'port_link',
                                'title' => __( 'Portfolio Link', 'brifa' ),
                                'type'  => 'text',
                            ),
                        )
                    ),

                )
            ),

        )
    );

    return $options;
}

add_filter( 'cs_metabox_options', 'brifa_portfolio_page' );