<?php
global $brifa_section_id;
$brifa_section_meta = get_post_meta( $brifa_section_id, 'brifa-section-blog', true );


$brifa_section             = get_post( $brifa_section_id );
$brifa_section_title       = $brifa_section->post_title;
$brifa_section_description = $brifa_section->post_content;

?>


    <!--blogs-->
    <section class="bisa-blogs">
        <div class="container">
            <div class="row">
                <div class="col-md-8 offset-md-2">
                    <div class="title blogs-title">
                        <h3><?php
                                echo esc_html( $brifa_section_title );
                                ?></h3>
                        <p><?php echo wp_kses_post($brifa_section_description); ?></p>
                    </div><!--/.title-->
                </div>
                <div class="w-100"></div>

                <?php $query_args = array(
                    'post_type' => 'post',
                    'posts_per_page' => 3 ,
                    'order' => 'DESC'
                );

                $query = new WP_Query( $query_args ); ?>

                <?php while ( $query->have_posts() ) : $query->the_post(); ?>
                <?php $brifa_blog_img = wp_get_attachment_image_src( get_post_thumbnail_id($post->ID), 'full' );?>
                <div class="col-md-4">
                    <div class="blog-single">
                        <div class="card">
                            <img src="<?php echo esc_url($brifa_blog_img[0]); ?>" alt="<?php the_title(); ?>"/>
                            <div class="card-body">
                                <p class="blog-meta">
                                    <?php the_category(' '); ?>
                                    <span class="date"><?php  _e('Posted ','brifa') ?> <?php echo get_the_date(); ?></span>
                                </p>
                                <h4><a href="<?php the_permalink(); ?>"><?php the_title(); ?></a></h4>
                                <p><?php $excerpt = get_the_excerpt();
                                    $excerpt = substr( $excerpt , 0, 200); 
                                     echo wp_kses_post( $excerpt );
                                      ?>
                                </p>
                                <a href="<?php the_permalink(); ?>" class="btn"><?php  _e('read more','brifa') ?></a>
                            </div>
                        </div>
                    </div><!--/.blog single-->
                </div>
                <?php endwhile; ?>

                <?php wp_reset_postdata(); ?>
                
                <?php wp_reset_query(); ?>


            </div>
        </div><!--/.container-->
    </section>
    <!--/.blogs-->