<div class="sidebar-widget">
    <?php
    if ( is_active_sidebar( "sidebar-1" ) ) {
        dynamic_sidebar( "sidebar-1" );
    }
    ?>
    <!--popular-post-->
    <div class="sidebar-popular-post">
        <h3><?php _e( "Popular Posts", "brifa" ); ?></h3>
        <ul class="list-unstyled">
        <?php
            $brifa_popular_posts = new WP_Query( array(
                'posts_per_page'      => 3,
                'ignore_sticky_posts' => 1,
                'orderby'             => "comment_count"
            ) );
            while ( $brifa_popular_posts->have_posts() ) {
                $brifa_popular_posts->the_post();
                ?>
                <li class="media">
                    <?php the_post_thumbnail('custom-size-popular',array('class'=>'mr-3')); ?>
                    <div class="media-body">
                      <a href="<?php the_permalink(); ?>"><?php the_title(); ?></a>
                      <p><?php echo get_the_date(); ?></p>
                    </div>
                </li>
                <?php
            }
            wp_reset_query();
            ?>
        </ul>


    </div>
    <!--/.popular-post-->

    <!--widget-categories-->
    <div class="widget-categories">
        <h3><?php _e('Categories:','brifa'); ?></h3>
        <ul>
            <?php wp_list_categories( array(
                'orderby'    => 'name',
                'show_count' => false,
                'title_li' => '',
                'exclude'    => array( 10 )
            ) ); ?> 
        </ul>
    </div>
    <!--widget-categories-->

    <!--widget-tags-->
    <div class="widget-tags">
        <?php
            $brifa_sidebar_tag_heading = apply_filters('brifa_sidebar_tag_heading',__('Tags:','brifa'));
            $brifa_sidebar_tag_items = apply_filters('brifa_sidebar_tag_items',get_tags());
        ?>
        <h3>
            <?php echo esc_html($brifa_sidebar_tag_heading); ?>
        </h3>

        <ul>
            <?php
            if(is_array($brifa_sidebar_tag_items)){
                foreach($brifa_sidebar_tag_items as $pti){
                    printf('<li><a href="%s">%s</a></li>',get_term_link($pti->term_id),$pti->name);
                }
            }
            ?>
        </ul> 

        <div style="display: none">
            <?php echo get_the_tag_list(); ?>
        </div>
    </div>
    <!--widget-tags-->

</div><!--/."sidebar-widget-->